package jcg.zheng.demo;

public class DemoClass {

	/**
	 * A static class must be created inside a class.
	 * 
	 * It can be accessed by outer class name. It can access static data members of
	 * outer class including private.
	 * 
	 * It cannot access non-static data members and methods.
	 *
	 * 
	 */
	static class DemoStaticClass {
		public DemoStaticClass(int someId) {
			super();
			this.someId = someId;
		}

		private static String message = "Static message inside a nested static class";
		
		private int someId;

		public String saySomething() {
			return instanceCount + " is from outer-class private static member.  " + message + " and " + someId;
		}

	}

	private static String commonMsg;

	// static members belong to the class, so it's not cleaned by the garbage
	// collection
	private static int instanceCount;

	// static block is executed during the class is loaded in memory
	static {
		instanceCount = 0;
	}

	// multiple static blocks are executed based on its order
	static {
		commonMsg = "Mary likes flowers";
	}

	public static int getInstanceCount() {
		return instanceCount;
	}

	private String name;

	public DemoClass(String name) {
		super();
		setName(name);

		instanceCount++;
	}

	public String getName() {
		return name;
	}

	public void sayHello() {
		DemoStaticClass demo = new DemoStaticClass(2);
		System.out.println(getName() + " " + demo.saySomething() + commonMsg);
	}

	public void setName(String name) {
		this.name = name;
	}

}
