package jcg.zheng.demo;

import static org.junit.jupiter.api.Assertions.assertEquals;

import org.junit.jupiter.api.RepeatedTest;
import org.junit.jupiter.api.Test;

public class DemoClassTest {
	
	private DemoClass dClass;

	@Test
	public void test_static_method() {
		assertEquals(0, DemoClass.getInstanceCount());
		for (int i = 1; i < 10; i++) {
			dClass = new DemoClass("Mary" + i);
			assertEquals("Mary" + i, dClass.getName());
			assertEquals(i, DemoClass.getInstanceCount());

			dClass.sayHello();
		}
	}

	@RepeatedTest(10)
	public void test_static_methods() {
		assertEquals(0, DemoClass.getInstanceCount());
	}

	@Test
	public void test_nested_static_class() {
		DemoClass.DemoStaticClass nestedCls = new DemoClass.DemoStaticClass(4);
		assertEquals("0 is from outer-class private static member.  Static message inside a nested static class and 4", nestedCls.saySomething());
	}
}
